
%MACRO DISP1;
%macro winDISP1;
DATA _NULL_;
WINDOW MDISP1 COLOR=grey
#1 "DISSOLUTION ACCEPTANCE LIMIT PROGRAM" C=yellow
#2 "FOR SAMPLING PLAN 1 (ONE SAMPLE PER LOCATION)" C=yellow
#4 "ENTER Q VALUE: " C=blue  Q 4.1 A=UNDERLINE
#5  "ENTER SAMPLE SIZE:  " C=blue NUMBER 4.0 A=UNDERLINE
#7  "ENTER BOUND ON FUTURE PERCENTAGE PASSING (50.0-99.0):  "
     C=blue LBOUND 4.1 A=UNDERLINE
#8  "ENTER CONFIDENCE LEVEL (50.0-99.0):  " C=blue CILEVEL 4.1 A=UNDERLINE
#10 "DO YOU WANT TO PRINT THE ACCEPTANCE LIMIT TABLE?" C=blue
#11 "ENTER Y OR N ="  C=blue A1DISP1 $1.
#13 "DO YOU WANT TO EVALUATE THE ACCEPTANCE LIMIT TABLE?" C=blue
#14 "ENTER Y OR N ="  C=blue A2DISP1 $1.
#16 "DO YOU WANT THE LOWER BOUND FOR A SPECIFIC SAMPLE RESULT?"
    C=blue
#17 "ENTER Y OR N ="  C=blue A3DISP1 $1.;
WINDOW SDISP1 COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "SAMPLE SIZE MUST BE AN INTEGER GREATER THAN 2" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW BDISP1 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "THE LOWER BOUND ON THE PERCENTAGE OF ALL FUTURE BATCHES" C=YELLOW
#2 "PASSING THE USP TEST MUST BE BETWEEN 50.0 AND 99.0" C=YELLOW
#3 "(TYPICAL VALUES ARE 50.0 AND 95.0)" C=YELLOW
#5 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW QDISP1 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "VALUES FOR Q MUST BE BETWEEN 40 AND 95" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW CIDISP1 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "CONFIDENCE INTERVAL VALUES MUST BE BETWEEN 50.0 AND 99.0" C=YELLOW
#2 "(TYPICAL VALUES ARE 90.0, 95.0, OR 99.0)" C=YELLOW
#4 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW ANSDISP1 COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "REQUESTS REQUIRE A RESPONSE OF: Y OR N" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
Q=80.0;
NUMBER=6;
LBOUND = 95;
CILEVEL = 95;
A1DISP1 = 'Y';
A2DISP1 = 'N';
A3DISP1 = 'N';
MAINDI1:
DISPLAY MDISP1 BELL;
IF NUMBER  LE 2 OR NUMBER NE ROUND(NUMBER) THEN DO;
DISPLAY SDISP1 BELL;
GOTO MAINDI1;
END;
IF Q GT 95.0 OR Q LT 40.0 THEN DO;
DISPLAY QDISP1 BELL;
GOTO MAINDI1;
END;

IF LBOUND GT 99.0 OR LBOUND LT 50.0 THEN DO;
DISPLAY BDISP1 BELL;
GOTO MAINDI1;
END;
IF CILEVEL GT 99.0 OR CILEVEL LT 50.0 THEN DO;
DISPLAY CIDISP1 BELL;
GOTO MAINDI1;
END;
IF A1DISP1 NE 'Y' AND A1DISP1 NE 'N' AND A1DISP1 NE 'y' AND
   A1DISP1 NE 'n' THEN DO;
DISPLAY ANSDISP1 BELL;
GOTO MAINDI1;
END;
IF A2DISP1 NE 'Y' AND A2DISP1 NE 'N' AND A2DISP1 NE 'y' AND
   A2DISP1 NE 'n' THEN DO;
DISPLAY ANSDISP1 BELL;
GOTO MAINDI1;
END;
IF A3DISP1 NE 'Y' AND A3DISP1 NE 'N' AND A3DISP1 NE 'y' AND
   A3DISP1 NE 'n' THEN DO;
DISPLAY ANSDISP1 BELL;
GOTO MAINDI1;
END;

CALL SYMPUT("Q",PUT(Q,4.1));
CALL SYMPUT("A1DISP1",PUT(UPCASE(A1DISP1),$1.));
CALL SYMPUT("A2DISP1",PUT(UPCASE(A2DISP1),$1.));
CALL SYMPUT("A3DISP1",PUT(UPCASE(A3DISP1),$1.));
CALL SYMPUT("NUMBER",PUT(NUMBER,4.0));
CALL SYMPUT("LBOUND",PUT(LBOUND,4.1));
CALL SYMPUT("CILEVEL",PUT(CILEVEL,4.1)); STOP;
RUN;
%mend winDISP1;

%MACRO COMPUTE;
   F1 = (1 - PROBNORM((5 - LLU)/SIGMA)) ** 6;
   SN2 = SQRT(12);
   PM2 = PROBNORM (SN2 * -LLU / SIGMA);
   PB2 = 1 - PROBNORM ((-15 - LLU) / SIGMA);
   F2 = PB2 ** 12 - PM2;
   SN3 = SQRT(24);
   PM3 = PROBNORM (SN3 * -LLU / SIGMA);
   P2 = PROBNORM ((-15 - LLU) / SIGMA) - PROBNORM ((-25 - LLU) / SIGMA);
   P3 = 1 - PROBNORM ((-15 - LLU) / SIGMA);
   F3 = P3**24 + 24*P2*P3**23 + 276*P2*P2*P3**22 - PM3;
   OVERBD = MAX(F1, F2, F3);
%mend compute;


%MACRO CALDISP1;
DATA D1ONE;
   Q = &Q;
   LIM = 100 - Q;
   N = &NUMBER;
   D=0.2;
   Z = PROBIT(SQRT(&CILEVEL / 100));
   CHI = CINV(1 - SQRT(&CILEVEL / 100),N - 1);
   STARTSD = 0.002;
   DO MEANADJ = D TO LIM BY D;
      BEGIN = STARTSD;
    DO SAMPSD = BEGIN TO 60.0 BY 0.001;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEANADJ - Z *SIGMA / SQRT(N);
%COMPUTE
   IF OVERBD < &LBOUND/100 AND SAMPSD <= 0.00201 then do;
   CV = 0; OUTPUT; SAMPLSD = 65.0; GOTO NEXT; END;
   IF OVERBD < &LBOUND/100 THEN DO;
      SAMPSD = SAMPSD - 0.001;
      STARTSD = SAMPSD;
      MEAN = MEANADJ + Q;
      CV = 100 * SAMPSD / MEAN;
       OUTPUT;
       SAMPSD = 65.0;
       END;
    NEXT:
     END;
    END;
  KEEP CV MEAN ;
PROC SORT DATA=D1ONE; BY MEAN;
DATA
     ONE(RENAME = (MEAN = X1 CV = CV1))
     TWO(RENAME = (MEAN = X2 CV = CV2))
     THREE(RENAME = (MEAN = X3 CV = CV3))
     FOUR(RENAME = (MEAN = X4 CV = CV4))
     FIVE(RENAME = (MEAN = X5 CV = CV5));
 SET D1ONE;
    Q = &Q;
    LIM = 100 - Q;
 IF Q                  < MEAN <= Q+ LIM/5   + 0.0001 THEN OUTPUT ONE;
 IF Q+LIM/5   + 0.0001 < MEAN <= Q+ 2*LIM/5 + 0.0001 THEN OUTPUT TWO;
 IF Q+2*LIM/5 + 0.0001 < MEAN <= Q+ 3*lIM/5 + 0.0001 THEN OUTPUT THREE;
 IF Q+3*LIM/5 + 0.0001 < MEAN <= Q+ 4*LIM/5 + 0.0001 THEN OUTPUT FOUR;
 IF Q+4*LIM/5 + 0.0001 < MEAN <= Q+ LIM     + 0.0001 THEN OUTPUT FIVE;
DATA D1ALL;
   MERGE ONE TWO THREE FOUR FIVE;
RUN;

%MEND CALDISP1;

%MACRO PRTDISP1;
OPTIONS MISSING = ' ' NODATE NONUMBER;
OPTIONS LS=132;
PROC PRINT DATA=D1ALL SPLIT = '*';
   FORMAT CV1 CV2 CV3 CV4 CV5 5.2;
   LABEL
         X1 = '  MEAN*(% CLAIM)'
         X2 = '  MEAN*(% CLAIM)'
         X3 = '  MEAN*(% CLAIM)'
         X4 = '  MEAN*(% CLAIM)'
         X5 = '  MEAN*(% CLAIM)'
         CV1 = 'CV*(%)'
         CV2 = 'CV*(%)'
         CV3 = 'CV*(%)'
         CV4 = 'CV*(%)'
         CV5 = 'CV*(%)';
      VAR CV1 X2 CV2 X3 CV3 X4 CV4 X5 CV5;
      ID X1;
TITLE "ACCEPTANCE LIMITS FOR DISSOLUTION (N = &NUMBER, Q = &Q)";
TITLE2 'SAMPLING PLAN 1';
TITLE3 "(MEETING LIMITS GUARANTEES WITH &CILEVEL % ASSURANCE,";
TITLE4 "THAT AT LEAST &LBOUND% OF ALL FUTURE SAMPLES TESTED";
TITLE5 'FOR DISSOLUTION WILL PASS THE USP TEST)';
TITLE6 "TABLE ENTRY IS UPPER LIMIT ON CV OF &NUMBER DISSOLUTION ASSAYS";
%MEND PRTDISP1;


%MACRO EVDISP1;

DATA _NULL_; WINDOW SMAIN COLOR=GREY
#1  "TO EVALUATE LIMITS, THE USER MUST SPECIFY THE RANGE OF" C=yellow
#2  "POSSIBLE POPULATION VALUES FOR THE MEAN AND CV" C=yellow
#3  "ENTER ALL VALUES AS POSITIVE INTEGERS" C=yellow
#5  "ENTER LOWER BOUND FOR MEAN: " C=blue ULOW 4.0 A=UNDERLINE
#6  "ENTER UPPER BOUND FOR MEAN: " C=blue UHIGH 4.0 A=UNDERLINE
#7  "ENTER INCREMENT FOR MEAN:   " C=blue UINCRE 4.0 A=UNDERLINE
#8  "ENTER DIVISOR FOR MEAN:     " C=blue UDIV 4.0 A=UNDERLINE
#10 "ENTER LOWER BOUND FOR CV:   " C=blue CVLOW 4.0 A=UNDERLINE
#11 "ENTER UPPER BOUND FOR CV:   " C=blue CVHIGH 4.0 A=UNDERLINE
#12 "ENTER INCREMENT FOR CV:     " C=blue CVINCRE 4.0 A=UNDERLINE
#13 "ENTER DIVISOR FOR CV:       " C=blue CVDIV 4.0 A=UNDERLINE;
WINDOW PINT COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ALL VALUES MUST BE POSITIVE INTEGERS" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW ORD  COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ERROR: UPPER BOUND IS LESS THAN LOWER BOUND" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
ULOW=950;
UHIGH=1000;
UINCRE=50;
UDIV=10;
CVLOW=10;
CVHIGH=40;
CVINCRE=30;
CVDIV=10;
SMAIN:
DISPLAY SMAIN BELL;
IF ULOW LT 1 OR ROUND(ULOW) NE ULOW
OR UHIGH LT 1 OR ROUND(UHIGH) NE UHIGH
OR UINCRE LT 1 OR ROUND(UINCRE) NE UINCRE
OR UDIV LT 1 OR ROUND(UDIV) NE UDIV
OR CVLOW LT 1 OR ROUND(CVLOW) NE CVLOW
OR CVHIGH LT 1 OR ROUND(CVHIGH) NE CVHIGH
OR CVINCRE LT 1 OR ROUND(CVINCRE) NE CVINCRE
OR CVDIV LT 1 OR ROUND(CVDIV) NE CVDIV
THEN DO;
DISPLAY PINT;
GOTO SMAIN;
END;
IF ULOW GT UHIGH
OR CVLOW GT CVHIGH
THEN DO;
DISPLAY ORD;
GOTO SMAIN;
END;
CALL SYMPUT("ULOW",PUT(ULOW,4.0));
CALL SYMPUT("UHIGH",PUT(UHIGH,4.0));
CALL SYMPUT("UINCRE",PUT(UINCRE,4.0));
CALL SYMPUT("UDIV",PUT(UDIV,4.0));
CALL SYMPUT("CVLOW",PUT(CVLOW,4.0));
CALL SYMPUT("CVHIGH",PUT(CVHIGH,4.0));
CALL SYMPUT("CVINCRE",PUT(CVINCRE,4.0));
CALL SYMPUT("CVDIV",PUT(CVDIV,4.0)); STOP;
RUN;

DATA DIONE;
   SET d1one;
   x = mean;
   std = x*cv/100;
   N = &NUMBER;

%MACRO SIGDISP1;

   %DO CV = &CVLOW %TO &CVHIGH %BY &CVINCRE;
      %DO U = &ULOW %TO &UHIGH %BY &UINCRE;

         DATA D1SAVE;
            SET DIONE END = LAST;
            U = &U / &UDIV;
            CV = &CV / &CVDIV;
            SIGMA = U * CV / 100;
            PMEAN = PROBNORM((x - U) * SQRT(N) / SIGMA)
                    - PROBNORM((LAG(X) - U) * SQRT(N) / SIGMA);
            AVEHT = (STD + LAG(STD)) / 2;
            PSTD = PROBCHI((N - 1) * AVEHT * AVEHT
                   / ( SIGMA * SIGMA), N - 1);
            PT = PMEAN * PSTD ;
            PTRAP + PT;
            IF X > 99.9 THEN DO;
               PMEAN = 1 - PROBNORM((X - U) * SQRT (N) / SIGMA);
               PSTD = PROBCHI((N - 1) * STD * STD
                      / ( SIGMA * SIGMA), N - 1);
               PT = PMEAN * PSTD;
               PTRAP + PT;
            END;
            IF LAST THEN OUTPUT;
         RUN;

PROC APPEND BASE = D1SAVALL DATA = D1SAVE;

       %END;
    %END;

%MEND SIGDISP1;

%SIGDISP1

PROC PRINT DATA = D1SAVALL split = '*';
   label ptrap = 'PROBABILITY*OF*PASSING';
   VAR CV PTRAP;
   ID U;
TITLE  "ACCEPTANCE LIMITS FOR DISSOLUTION (N = &NUMBER, Q = &Q)";
TITLE2 'SAMPLING PLAN 1';
TITLE3 'PROBABILITY OF PASSING ACCEPTANCE LIMIT TABLE';
TITLE4 "CONFIDENCE LEVEL = &CILEVEL AND LOWER BOUND = &LBOUND";
RUN;
%MEND EVDISP1;

%MACRO SMPDISP1;

DATA _NULL_; WINDOW TMAIN COLOR=GREY
#3 "TO DETERMINE LOWER BOUND FOR FOUND SAMPLE RESULTS" C=yellow
#5  "ENTER SAMPLE MEAN (% CLAIM): " C=blue MEAN 6.3 A=UNDERLINE
#6  "ENTER SAMPLE CV (%):         " C=blue CV 6.3 A=UNDERLINE;
WINDOW LTZ COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "CV MUST BE NON NEGATIVE" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW RANGE COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "MEAN MUST BE GREATER THAN Q" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
MEAN= 100.00;
CV=4.00;
TMAIN:
DISPLAY TMAIN BELL;
IF CV LE 0 THEN DO;
DISPLAY LTZ;
GOTO TMAIN;
END;
IF MEAN LE &Q THEN DO;
DISPLAY RANGE;
GOTO TMAIN;
END;
CALL SYMPUT("MEAN",PUT(MEAN,6.3));
CALL SYMPUT("CV",PUT(CV,6.3)); STOP;
RUN;

DATA DI1SMP;
LABEL OVERBD = 'OVERALL LOWER BOUND'
       MEAN = 'SAMPLE MEAN(%CLAIM)';
   Q = &Q;
   N = &NUMBER;
   CILEVEL = &CILEVEL;
   Z = PROBIT(SQRT(&CILEVEL / 100));
   N = &NUMBER;
   CHI = CINV(1 - SQRT(&CILEVEL / 100),N - 1);
      MEAN = &MEAN;
      MEANADJ = MEAN - Q;
      CV = &CV;
      SAMPSD= &MEAN * CV/100;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEANADJ - Z *SIGMA / SQRT(N);
%COMPUTE
PROC PRINT SPLIT = '*';
  LABEL SAMPSD = 'SAMPLE*STD DEV*(% CLAIM)'
        MEAN = 'SAMPLE* MEAN*(% CLAIM)'
        OVERBD = 'LOWER BOUND';

  ID MEAN;
  VAR SAMPSD CV OVERBD;
TITLE  "ACCEPTANCE LIMITS FOR DISSOLUTION (N = &NUMBER, Q = &Q)";
TITLE2 'SAMPLING PLAN 1';
TITLE3 "PROPORTION OF FUTURE SAMPLES PASSING THE USP TEST";
TITLE4 "FOR A GIVEN SAMPLE MEAN AND CV WITH &CILEVEL.% ASSURANCE";
run;
%MEND SMPDISP1;

%MACRO ANADISP1;
    %winDIsp1;
%IF %UPCASE(&A1DISP1)=Y OR %UPCASE(&A2DISP1)=Y %THEN %DO;
     %CALDISP1;
    %END;
%IF %UPCASE(&A1DISP1)=Y %THEN %DO;
      %PRTDISP1;
    %END;
%IF %UPCASE(&A2DISP1)=Y %THEN %DO;
      %EVDISP1;
PROC DATASETS LIBRARY = WORK;
   DELETE D1SAVALL;
    %END;
%IF %UPCASE(&A3DISP1)=Y %THEN %DO;
      %SMPDISP1;
    %END;
%MEND ANADISP1;

%ANADISP1
RUN;
%MEND DISP1;
%DISP1
